## 1 Ihmisiä ja koiria

**Tehtävä**

Kurssin viimeisessä tehtävässä sinun tulee kirjoittaa kaksi luokkaa: Koira ja Isanta. Alla oleva pääohjelma käyttää kirjoittamiasi luokkia ja tehtävän tarkoituksena on, että osaisit rakentaa luokat tulkitsemalla pääohjelmaa, sekä esimerkkitulostusta, jonka pääohjelma muodostaa kun luokat on toteutettu oikein. Seuraavassa muutama vihje, joiden pitäisi helpottaa luokkien rakentamista:

- Isännällä voi olla koira, mutta vaikka koiralla olisi isäntä, se "ei tiedä" isännästään mitään.

- Kun luokasta Ihminen muodostetaan uusi ihminen, ihminen ei saa automaattisesti koiraa vastuulleen.

- Kun ihmistä pyydetään kävelyttämään koiraa, riippuu ihmisen toiminta siitä, onko hänellä koira vastuullaan.

Alla näet pääohjelman, jolla luokkiasi testataan:

```
int main()
{
  string koiran_nimi, ihmisen_nimi;
  cout << "Anna ihmisen nimi: ";
  cin >> ihmisen_nimi;
  cout << "Anna koiran nimi: ";
  cin >> koiran_nimi;

  cout << endl;

  Ihminen* isanta = new Ihminen(ihmisen_nimi);
  Koira* rekku = new Koira(koiran_nimi);

  isanta->KavelytaKoiraa(7);
  rekku->Hauku();

  isanta->OtaVastuuKoirasta(rekku);  
  isanta->KavelytaKoiraa(7);

  rekku->Hauku();

  return 0;
}
```

Example output:

```
Anna ihmisen nimi: Simo
Anna koiran nimi: Rex
Simo: Mutta eihän minulla ole koiraa...
Rex: Hau hau! Olen kävellyt 0 kilometriä.
Simo: Rex käveli juuri 7 kilometriä.
Rex: Hau hau! Olen kävellyt 7 kilometriä.
```

**Vastaus:**

```
#include <iostream>
using namespace std;

class Ihminen;

class Koira
{
    public:
        Koira(string koiran_nimi);
        ~Koira();

        void   Hauku();
        string HaeNimi();
        void   AsetaIsanta(Ihminen* ihminen);

    private:
        string   koiran_nimi_;
        Ihminen* ihminen_;
};

class Ihminen
{
    public:
        Ihminen(string ihmisen_nimi);
        ~Ihminen();

        void KavelytaKoiraa(int matka);
        void OtaVastuuKoirasta(Koira* koira);
        int  HaeMatka();

    private:
        string ihmisen_nimi_;
        int    matka_;
        Koira* koira_;
};

Koira::Koira(string koiran_nimi) : koiran_nimi_(koiran_nimi)
{
}

Koira::Koira::~Koira()
{
    delete ihminen_;
}

string Koira::HaeNimi()
{
    return koiran_nimi_;
}

void Koira::AsetaIsanta(Ihminen* ihminen)
{
    ihminen_ = ihminen;
}

void Koira::Hauku()
{
    int matka;
    if (!ihminen_)
    {
        matka = 0;
    }
    else
    {
        matka = ihminen_->HaeMatka();
    }

    cout << koiran_nimi_ << ": Hau hau! Olen kävellyt " << matka << " kilometriä." << endl;
}

Ihminen::Ihminen(string ihmisen_nimi) : ihmisen_nimi_(ihmisen_nimi)
{
}

Ihminen::~Ihminen()
{
    delete koira_;
}

void Ihminen::OtaVastuuKoirasta(Koira* koira)
{
    // Sido koira-olio tähän ihmisolioon
    koira_ = koira;
    // Sido tämä ihmisolio koira-olioon
    koira_->AsetaIsanta(this);
}

void Ihminen::KavelytaKoiraa(int matka)
{

    if (!koira_)
    {
        // Jos mitään koira-oliota ei ole sidottu tähän ihmisolioon
        cout << ihmisen_nimi_ << ": Mutta eihän minulla ole koiraa..." << endl;
    }
    else
    {
        // Jos koira-olio on sidottu tähän ihmisolioon
        matka_ = matka;
        cout << ihmisen_nimi_ << ": " << koira_->HaeNimi() << " käveli juuri " << matka_ << " kilometriä." << endl;
    }
}

int Ihminen::HaeMatka()
{
    return matka_;
}

//

//** Pre-defined code in the assignment **//
int main()
{
  string koiran_nimi, ihmisen_nimi;

  cout << "Anna ihmisen nimi: ";
  cin >> ihmisen_nimi;

  cout << endl;

  cout << "Anna koiran nimi: ";
  cin >> koiran_nimi;

  cout << endl;

  Ihminen* isanta = new Ihminen(ihmisen_nimi);
  Koira* rekku = new Koira(koiran_nimi);

  isanta->KavelytaKoiraa(7);
  rekku->Hauku();

  isanta->OtaVastuuKoirasta(rekku);
  isanta->KavelytaKoiraa(7);

  rekku->Hauku();

  return 0;
}
//** ---------- ---------- ---------- **//
```
