# C++ basics

C++ fundamentals through coding exercises.

Contents of this repository are based on [C++ programming course material](https://campusonline.fi/course/olio-ohjelmointi-c/) provided by Metropolia University of Applied Sciences.

**NOTE**: Assignments and their descriptions are in Finnish for meanwhile. I have a plan to translate them to English.

**NOTE**: In real world, class declarations should _always_ be done in header files. These assignments are quite simple and used single `cpp` files including all code required for programs.

## Contents

- [Fundamentals](1_fundamentals)

    - Description: C++ syntax, functions, `for` & `while` loop

- [Classes and methods](2_classes-and-methods)

    - Description: Classes and methods in C++

- [Creating a class](3_creating-class)

    - Description: Class structure, visibility and data handling

- [Pointers, reference variables and memory handling](4_pointers-vars-and-memory-handling)

    - Description: Pointers, reference variables and basic memory handling in C++

- [Object lifetime](5_object-lifetime)

    - Description: Object constructors and destructors in C++

- [UML principles](6_uml-principles)

    - Description: Understanding and implementing UML schemas as C++ code

- [Class relations](7_class-relations)

    - Description: Relations between multiple classes

- [Inheritance](8_inheritance)

    - Description: Basics of inheritance, polymorfism, parent & child classes, virtual functions

- [Shallow and deep copy](9_shallow-and-deep-copy)

    - Description: Basics of object shallow and deep copy operations in C++
